commit 6308a4af1a4a5656872ce22272bc9f85d3c1b0a4
Author: Kay Sievers <kay.sievers@vrfy.org>
Date:   Thu Mar 11 15:04:44 2010 +0100

    volume_id: add btrfs support

diff --git a/extras/volume_id/lib/Makefile.am b/extras/volume_id/lib/Makefile.am
index 59a5ac9..835faff 100644
--- a/extras/volume_id/lib/Makefile.am
+++ b/extras/volume_id/lib/Makefile.am
@@ -45,7 +45,8 @@ libvolume_id_la_SOURCES =\
 	vxfs.c \
 	squashfs.c \
 	netware.c \
-	oracleasm.c
+	oracleasm.c \
+	btrfs.c
 
 libvolume_id_la_LDFLAGS = \
 	-version-info $(VOLID_LT_CURRENT):$(VOLID_LT_REVISION):$(VOLID_LT_AGE) \
diff --git a/extras/volume_id/lib/btrfs.c b/extras/volume_id/lib/btrfs.c
new file mode 100644
index 0000000..fd5d9ce
--- /dev/null
+++ b/extras/volume_id/lib/btrfs.c
@@ -0,0 +1,102 @@
+/*
+ * volume_id - reads filesystem label and uuid
+ *
+ * Copyright (C) 2008 Kay Sievers <kay.sievers@vrfy.org>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE 1
+#endif
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <errno.h>
+#include <ctype.h>
+#include <byteswap.h>
+
+#include "libvolume_id.h"
+#include "libvolume_id-private.h"
+
+struct btrfs_super_block {
+	uint8_t csum[32];
+	uint8_t fsid[16];
+	uint64_t bytenr;
+	uint64_t flags;
+	uint8_t magic[8];
+	uint64_t generation;
+	uint64_t root;
+	uint64_t chunk_root;
+	uint64_t log_root;
+	uint64_t log_root_transid;
+	uint64_t total_bytes;
+	uint64_t bytes_used;
+	uint64_t root_dir_objectid;
+	uint64_t num_devices;
+	uint32_t sectorsize;
+	uint32_t nodesize;
+	uint32_t leafsize;
+	uint32_t stripesize;
+	uint32_t sys_chunk_array_size;
+	uint64_t chunk_root_generation;
+	uint64_t compat_flags;
+	uint64_t compat_ro_flags;
+	uint64_t incompat_flags;
+	uint16_t csum_type;
+	uint8_t root_level;
+	uint8_t chunk_root_level;
+	uint8_t log_root_level;
+	struct btrfs_dev_item {
+		uint64_t devid;
+		uint64_t total_bytes;
+		uint64_t bytes_used;
+		uint32_t io_align;
+		uint32_t io_width;
+		uint32_t sector_size;
+		uint64_t type;
+		uint64_t generation;
+		uint64_t start_offset;
+		uint32_t dev_group;
+		uint8_t seek_speed;
+		uint8_t bandwidth;
+		uint8_t uuid[16];
+		uint8_t fsid[16];
+	} PACKED dev_item;
+	uint8_t label[256];
+} PACKED;
+
+int volume_id_probe_btrfs(struct volume_id *id, uint64_t off, uint64_t size)
+{
+	const uint8_t *buf;
+	struct btrfs_super_block *bfs;
+
+	info("probing at offset 0x%llx\n", (unsigned long long) off);
+
+	buf = volume_id_get_buffer(id, off + 0x10000, 0x200);
+	if (buf == NULL)
+		return -1;
+	bfs = (struct btrfs_super_block *)buf;
+	if (memcmp(bfs->magic, "_BHRfS_M", 8) != 0)
+		return -1;
+	volume_id_set_uuid(id, bfs->fsid, 0, UUID_DCE);
+	// volume_id_set_uuid_sub(id, bfs->dev_item.uuid, 0, UUID_DCE);
+	volume_id_set_label_raw(id, bfs->label, 256);
+	volume_id_set_label_string(id, bfs->label, 256);
+	volume_id_set_usage(id, VOLUME_ID_FILESYSTEM);
+	id->type = "btrfs";
+	return 0;
+}
diff --git a/extras/volume_id/lib/libvolume_id-private.h b/extras/volume_id/lib/libvolume_id-private.h
index 2ce4650..e3eaeec 100644
--- a/extras/volume_id/lib/libvolume_id-private.h
+++ b/extras/volume_id/lib/libvolume_id-private.h
@@ -152,6 +152,7 @@ extern int volume_id_probe_squashfs(struct volume_id *id, uint64_t off, uint64_t
 extern int volume_id_probe_netware(struct volume_id *id, uint64_t off, uint64_t size);
 extern int volume_id_probe_gfs(struct volume_id *id, uint64_t off, uint64_t size);
 extern int volume_id_probe_gfs2(struct volume_id *id, uint64_t off, uint64_t size);
+extern int volume_id_probe_btrfs(struct volume_id *id, uint64_t off, uint64_t size);
 
 /* special formats */
 extern int volume_id_probe_linux_swap(struct volume_id *id, uint64_t off, uint64_t size);
diff --git a/extras/volume_id/lib/volume_id.c b/extras/volume_id/lib/volume_id.c
index 9b7d91d..c9ad02b 100644
--- a/extras/volume_id/lib/volume_id.c
+++ b/extras/volume_id/lib/volume_id.c
@@ -83,6 +83,7 @@ static const struct prober prober_filesystem[] = {
 	{ volume_id_probe_squashfs, { "squashfs", } },
 	{ volume_id_probe_netware, { "netware", } },
 	{ volume_id_probe_oracleasm, { "oracleasm", } },
+	{ volume_id_probe_btrfs, { "btrfs", } },
 };
 
 /* the user can overwrite this log function */

